1200 '--------DST_R1.bas-----------
1210 '--Adjust Time For DST - for ref. only -------------
1220 'Author: Hacker - DuinoMiteMegaAndy
1230 'Date: 17/12/2011
1240 'App. Version: Rev. 1.0b
1250 'MMBasic Firmware: 2.7 DuinoMite Mega
1260 'Platform: Win XP/SP3
1270 '
1280 '
1290 '----------Code Begin--------------
1300 'Spring Forward and Fall Back Dates for time change at 02:00 AM.
1310 'DST data date format matches PIC32 Date$: Month/Day/Year xxxx
1320 DATA "11-3-2012","4-11-2012","10-3-2013","11-3-2013","9-3-2014"
1330 DATA "2-11-2014", "8-3-2015","1-11-2015","13-3-2016","6-11-2016"
1340 DATA "12-3-2017","5-11-2017","11-3-2018","4-11-2018","10-3-2019"
1350 DATA "3-11-2019" 
1360 DIM DSTDate$(15)
1370 'Read data into zero base array
1380 FOR I=0 TO 15 ' 8 years of DST dates 
1390 READ DSTDate$(I)
1400 NEXT I
1410 FOR I=0 TO 15 ' 8 years of DST dates
1420 IF DATE$ = DSTDate$(I) THEN GOTO 1530
1430 NEXT I
1440 '? "DST Key Not Found!"
1450 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1460 ? #9, "NO_DST_KEY"
1470 CLOSE #9
1480 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
1490 ? #8, "DST_UNLOCKED"
1500 CLOSE #8
1510 ? "DST Date Not Found!" 
1520 RETURN '<---<<<<
1530 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1540 ? #9, "DST_IS_TODAY"
1550 CLOSE #9
1560 OPEN "B:CHKDST.dat" FOR INPUT AS #9
1570 INPUT #9, key$
1580 CLOSE #9
1590 OPEN "B:Lockout.dat" FOR INPUT AS #8
1600 INPUT #8, lockout$
1610 CLOSE #8 
1620 IF key$ = "DST_IS_TODAY" AND lockout$ = "DST_UNLOCKED" THEN GOTO 1650
1630 ? "DST Has been done once - DST Lockout"   
1640 RETURN ' <---<<<
1650 tempdec = VAL(LEFT$(TIME$, 2))
1660 hours_dec = tempdec 
1670 GOSUB 2230
1680 hours = hex
1690 tempdec = VAL(MID$(TIME$, 4, 2)) 
1700 GOSUB 2230
1710 minutes = hex
1720 tempdec = VAL(RIGHT$(TIME$, 2))
1730 GOSUB 2230
1740 seconds = hex
1750 tempdec = VAL(LEFT$(DATE$, 2))
1760 DOW_DAY = tempdec
1770 GOSUB 2230
1780 day = hex
1790 tempdec = VAL(MID$(DATE$, 4, 2))
1800 month_dec = tempdec
1810 DOW_MONTH = tempdec 
1820 GOSUB 2230
1830 month = hex
1840 tempdec = (VAL(RIGHT$(DATE$, 4)) - 2000)
1850 DOW_YEAR = tempdec
1860 GOSUB 2230
1870 year = hex
1880 IF month_dec = 3 THEN GOTO 1920 'Spring forward +1 hr 
1890 IF month_dec = 11 THEN GOTO 1940 'Fall back -1 hr
1900 ? "ABORT ---> DST Month Error!"
1910 RETURN <----<<<<<
1920 IF hours_dec = 23 THEN hours_dec = 0: GOSUB 2230: GOTO 2070 ' ADD +1 to military time
1930 IF hours_dec >= 0 AND  hours_dec < 23  THEN hours_dec = hours_dec + 1:GOSUB 2230: GOTO 2070 ' ADD +1 to military time     
1940 IF hours_dec >= 1 AND  hours_dec <= 23 THEN hours_dec = hours_dec - 1:GOSUB 2230: GOTO 2070 ' SUBTRACT -1 to military time
1950 IF hours_dec = 0  THEN hours_dec = 23:GOSUB 2230:GOTO 2070  'SUBTRACT -1 to military time 
1960 a = (14 - dow_month) / 12
1970 a = FIX(a)
1980 y = dow_year - a
1990 y = FIX(y)
2000 m = dow_month + (12 * a) - 2
2010 m = FIX(m)
2020 d = ((dow_day + y) + FIX(y / 4) - FIX(y / 100) + FIX(y / 400) + FIX((31 * m) / 12)) 
2030 DOW = d MOD 7
2040 DOW = DOW + 1 ' offset for DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
2050 tempdec = DOW ' DOW dec
2060 GOSUB 1700 ' convert to hex BCD
2070 rtcwday = hex
2080 ' Write DST adjusted Time to DS3231 RTC
2090 i2caddr = &h68 ' DS3231 I2C address
2100 I2CEN 400,100 ' Enable I2C
2110 I2CSEND i2caddr, 0, 8, &h0, seconds, minutes, hours_dec, rtcwday, day, month, year 
2120 I2CDIS
2130 ? "0=ok 1=nack 2=timeout"; MM.I2C
2140 ? "DST has updated the DS3231 RTC!";
2150 OPEN "B:DST.dat" FOR OUTPUT AS #9 ' write status to dat file
2160 ? #9,"DST_UPDATED"
2170 ? #9,DATE$
2180 CLOSE #9
2190 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
2200 ? #8, "DST_LOCKED"
2210 CLOSE #8
2220 RETURN ' <---<<<< 
2230 'Convert to Hex
2240 hex = FIX(tempdec / 10) * 16
2250 hex = hex OR ((tempdec / 10) - (FIX(tempdec / 10))) * 10
2260 RETURN ' <---<<<<
2270 ' 
\
