10 '--------- Main_R1.bas --------------------
20 'Author: Hacker - DuinoMiteMegaAndy
30 'Date: 17/12/2011
40 'App. Version: Rev. 1.0b
50 'MMBasic Firmware: 2.7 DuinoMite Mega
60 'Platform: Win XP/SP3
70 '
80 '----------Code Begin--------------
90 CLS
100 PAUSE 1000
110 ? ""' lf
120 PRINT "Main Started ..."
130 '
140 '
150 '
160 'This time is close to the DST time update required by the US government. 
170 tempdec = VAL(RIGHT$(DATE$, 4))  
180 IF tempdec = 2000 THEN ? "PIC32 Clock Is Reset To Default --> ABORT!": END 
190 hrdec = VAL(LEFT$(TIME$, 2)) 'get hr val
200 mindec = VAL(MID$(TIME$, 4, 2)) 'get min val
210 SyncMin = 59 - mindec 
220 SyncHr = 0
230 IF hrdec = 0 THEN SyncHr = 1 :GOTO 270 
240 IF hrdec = 1 THEN SyncHr = 0 :GOTO 270 
250 IF hrdec => 2 AND hrdec <= 23 THEN SyncHr = 25 - hrdec: GOTO 270 
260 ? "UnKnown SyncHr --> ABORT!":end
270 SyncMilliSecs = (SyncMin * 60 * 1000) + (SyncHr * 3600 * 1000) 
280 SETTICK SyncMilliSecs, 550 ' 
290 '---------------------------------------------------------------------------
300 '                      User Application Code
310 '---------------------------------------------------------------------------
320 '
330 '
340 '
350 '
360 ' 
370 ' 
380 '  
390 '    
400 '
410 '
420 ? "Running User Code ..."
430 Pin(0) = 1 ' Grn LED On
440 Pause 1000
450 Pin(0) = 0 ' Grn LED Off
460 Pause 1000 
470 GoTO 430
480 '
490 '
500 '
510 '
520 '
530 '   
540 '---------------------Periodic Interrupt------------------------------------
550 oldtime$ = TIME$
560 olddate$ = DATE$
570 ? "Periodic Interrupt at ~ 2:00 AM Has Started ..."
580 ? "Checking DST For Today"
590 GOSUB 1410 'Check for DST and adjust DS3231
600 ? "Starting PIC32 RTC Refresh From DS3231 RTC ..."
610 GOSUB 760  'Update or refresh PIC32 RTC from DS3231 RTC
620 ? "PIC32 RTC Has Been Refreshed With The Precison DS3231 RTC"
630 ? "PIC32 OLD TIME = ",oldtime$
640 ? "PIC32 OLD DATE = ",olddate$
650 ? "PIC32 NEW TIME = ",TIME$
660 ? "PIC32 NEW DATE = ",DATE$      
670 SETTICK 0,0 ' clear periodic interrupt
680 SETTICK (24 * 3600 * 1000), 550 'Set periodic interrupt to every 24 hrs at 01:59 (1:59 AM)
690 IRETURN ' return to system application code
700 '   
710 '===========================================================================
720 'Update PIC32 RTC <-Enable AFTER DS3231 RTC has been installed and configured!
730 '===========================================================================
740 '
750 '----- GOSUB FOR RTC DAILY UPDATE---------------
760 DIM RTCBuff(8)
770 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
780 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout 
790 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 ' 
800 I2CDIS
810 '
820 BCDTEMP = RTCBuff(0) 'secs (00-59)
830 GOSUB 1220
840 sec$ = STR$(decimal)
850 '
860 BCDTEMP = RTCBuff(1) ' mins (00-59)
870 GOSUB 1220
880 min$ = STR$(decimal) '
890 '
900 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!
910 GOSUB 1220
920 hrs$ = STR$(decimal)
930 '
940 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time
950 oldTime$ = TIME$
960 TIME$ = T$
970 '
980 BCDTEMP = RTCBuff(3) ' dow - day of week (1-7)  Sunday = 1
990 GOSUB 1220
1000 dow$ = STR$(decimal)
1010 '
1020 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
1030 GOSUB 1220
1040 day$ = STR$(decimal)
1050 '
1060 BCDTEMP = RTCBuff(5) ' month - (01-12)
1070 GOSUB 1220
1080 month$ = STR$(decimal)
1090 '
1100 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000 
1110 GOSUB 1220
1120 decimal = decimal + 2000 ' adjust year + 2000
1130 year$ = STR$(decimal)
1140 '
1150 d$ = day$+"-"+month$+"-"+year$ ' <---- Update date (day/month/year + 2000)
1160 '
1170 '
1180 oldDate$ = DATE$
1190 DATE$ = d$
1200 RETURN
1210 ' --- Convert BCD to Decimal -----
1220 Decimal = FIX(BCDTemp / 16) * 10
1230 Decimal = Decimal + (BCDTEMP AND &hF)
1240 RETURN
1250 '==========================================================================
1260 '                   End of PIC32 RTC Time Date refresh update    
1270 '==========================================================================
1280 '                           
1290 '--------DST_R1.bas-----------
1300 '------------- Adjust Time For DST-------------
1310 'Author: Hacker - DuinoMiteAndy
1320 'Date: 27/11/2011
1330 'App. Version: Rev. 1.0b
1340 'MMBasic Firmware: 2.7 DuinoMite Mega
1350 'Platform: Win XP/SP3
1360 '
1370 '
1380 '----------Code Begin--------------
1390 'Spring Forward and Fall Back Dates for time change at 02:00 AM.
1400 'DST data date format matches PIC32 Date$: Month/Day/Year xxxx
1410 DATA "11-3-2012","4-11-2012","10-3-2013","11-3-2013","9-3-2014"
1420 DATA "2-11-2014", "8-3-2015","1-11-2015","13-3-2016","6-11-2016"
1430 DATA "12-3-2017","5-11-2017","11-3-2018","4-11-2018","10-3-2019"
1440 DATA "3-11-2019" 
1450 DIM DSTDate$(15)
1460 'Read data into zero base array
1470 FOR I=0 TO 15 ' 8 years of DST dates 
1480 READ DSTDate$(I)
1490 NEXT I
1500 FOR I=0 TO 15 ' 8 years of DST dates
1510 IF DATE$ = DSTDate$(I) THEN GOTO 1620
1520 NEXT I
1530 '? "DST Key Not Found!"
1540 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1550 ? #9, "NO_DST_KEY"
1560 CLOSE #9
1570 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
1580 ? #8, "DST_UNLOCKED"
1590 CLOSE #8
1600 ? "DST Date Not Found!" 
1610 RETURN '<---<<<<
1620 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1630 ? #9, "DST_IS_TODAY"
1640 CLOSE #9
1650 OPEN "B:CHKDST.dat" FOR INPUT AS #9
1660 INPUT #9, key$
1670 CLOSE #9
1680 OPEN "B:Lockout.dat" FOR INPUT AS #8
1690 INPUT #8, lockout$
1700 CLOSE #8 
1710 IF key$ = "DST_IS_TODAY" AND lockout$ = "DST_UNLOCKED" THEN GOTO 1740
1720 ? "DST Has been done once - DST Lockout"    
1730 RETURN ' <---<<<
1740 tempdec = VAL(LEFT$(TIME$, 2))
1750 hours_dec = tempdec 
1760 GOSUB 2310
1770 hours = hex
1780 tempdec = VAL(MID$(TIME$, 4, 2)) 
1790 GOSUB 2310
1800 minutes = hex
1810 tempdec = VAL(RIGHT$(TIME$, 2))
1820 GOSUB 2310
1830 seconds = hex
1840 tempdec = VAL(LEFT$(DATE$, 2))
1850 DOW_DAY = tempdec
1860 GOSUB 2310
1870 day = hex
1880 tempdec = VAL(MID$(DATE$, 4, 2))
1890 month_dec = tempdec
1900 GOSUB 2310 
1910 month = hex 
1920 tempdec = (VAL(RIGHT$(DATE$, 4)) - 2000)
1930 DOW_Year = tempdec
1940 GOSUB 2310
1950 year = hex
1960 IF month_dec = 3 THEN GOTO 2000 'Spring forward +1 hr 
1970 IF month_dec = 11 THEN GOTO 2020 'Fall back -1 hr
1980 ? "ABORT ---> DST Month Error!" ' check your DST array above!
1990 RETURN <----<<<<<
2000 IF hours_dec = 23 THEN hours_dec = 0: GOSUB 2310: GOTO 2150 ' ADD +1 to military time
2010 IF hours_dec >= 0 AND  hours_dec < 23  THEN hours_dec = hours_dec + 1:GOSUB 2310: GOTO 2150 ' ADD +1 to military time     
2020 IF hours_dec >= 1 AND  hours_dec <= 23 THEN hours_dec = hours_dec - 1:GOSUB 2310: GOTO 2150 ' SUBTRACT -1 to military time
2030 IF hours_dec = 0  THEN hours_dec = 23:GOSUB 2310: GOTO 2150  'SUBTRACT -1 to military time 
2040 a = (14 - dow_month) / 12
2050 a = FIX(a)
2060 y = dow_year - a
2070 y = FIX(y)
2080 m = dow_month + (12 * a) - 2
2090 m = FIX(m)
2100 d = ((dow_day + y) + FIX(y / 4) - FIX(y / 100) + FIX(y / 400) + FIX((31 * m) / 12)) 
2110 DOW = d MOD 7
2120 DOW = DOW + 1 ' offset for DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
2130 tempdec = DOW ' DOW dec
2140 GOSUB 1800 ' convert to hex BCD
2150 rtcwday= hex
2160 ' Write DST adjusted Time to DS3231 RTC
2170 i2caddr = &h68 ' DS3231 I2C address
2180 I2CEN 400,100 ' Enable I2C
2190 I2CSEND i2caddr, 0, 8, &h0, seconds, minutes, hours_dec, rtcwday, day, month, year 
2200 I2CDIS
2210 ? "0=ok 1=nack 2=timeout"; MM.I2C
2220 ? "DST has updated the DS3231 RTC!";
2230 OPEN "B:DST.dat" FOR OUTPUT AS #9 ' write status to dat file
2240 ? #9,"DST_UPDATED"
2250 ? #9,DATE$
2260 CLOSE #9
2270 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
2280 ? #8, "DST_LOCKED"
2290 CLOSE #8
2300 RETURN ' <---<<<< 
2310 'Convert to Hex
2320 hex = FIX(tempdec / 10) * 16
2330 hex = hex OR ((tempdec / 10) - (FIX(tempdec / 10))) * 10
2340 RETURN ' <---<<<<
2350 '    
