10 '--------- TD_R1.bas --------------------
20 'Author: Hacker - DuinoMiteMegaAndy
30 'Date: 17/12/2011
40 'App. Version: Rev. 1.0b
50 'MMBasic Firmware: 2.7 DuinoMite Mega
60 'Platform: Win XP/SP3
70 '
80 '
90 '
100 '----------Code Begin--------------
110 CLS
120 PRINT "******************************************"
130 PRINT "*  PIC32 DS3231 Time / Date Utilities    *"
140 PRINT "******************************************"
150 PRINT "* [A] <-- Print PIC32  Time/Date         *"
160 PRINT "* [B] <-- Print DS3231 Time/Date/DOW     *"
170 PRINT "* [C] <-- PIC32 RTC   <--<<<  DS3231 RTC *"
180 PRINT "* [D] <-- DST Daylight Savings Test Only *"
190 PRINT "* [E] <-- Spring FWD +1 Hr.   DS3231 RTC *"
200 PRINT "* [F] <-- Fall Back  -1 Hr.   DS3231 RTC *"
210 PRINT "* [G] <-- DS3231 RTC  <--<<<  PIC32  RTC *"
220 PRINT "* [H] <-- Manual Set/Config.  DS3231 RTC *"
230 PRINT "* [I] <-- Print/Compare PIC32/DS3231 RTC *"
240 PRINT "* [J] <-- Print PIC32 DOW - Day of Week  *"
250 PRINT "* [K] <-- Print PIC32 DOY - Day of Year  *"
255 PRINT "* [L] <-- Print Sunrise/Sunset Times     *"
260 PRINT "* [M] <-- GoTo Main Menu                 *"
270 PRINT "* [Q] <-- Quit Menu                      *"
280 PRINT "******************************************"
290 '
300 INPUT "Select Command Letter [x]"; Query$ 
310 IF Query$ = "a" OR Query$ = "A" THEN GOTO 480
320 IF Query$ = "b" OR Query$ = "B" THEN GOTO 530
330 IF Query$ = "c" OR Query$ = "C" THEN GOTO 580
340 IF Query$ = "d" OR Query$ = "D" THEN GOTO 700
350 IF Query$ = "e" OR Query$ = "E" THEN GOTO 600
360 IF Query$ = "f" OR Query$ = "F" THEN GOTO 620
370 IF Query$ = "g" OR Query$ = "G" THEN GOTO 640
380 IF Query$ = "h" OR Query$ = "H" THEN GOTO 660
390 IF Query$ = "i" OR Query$ = "I" THEN GOTO 680
400 IF Query$ = "j" OR Query$ = "J" THEN GOTO 750
410 IF Query$ = "k" OR Query$ = "K" THEN GOTO 770
420 IF Query$ = "m" OR Query$ = "M" THEN GOTO 560
425 IF Query$ = "l" OR Query$ = "L" THEN GOTO 785
430 IF Query$ = "q" OR Query$ = "Q" THEN GOTO 460 
440 PRINT "ABORT --> MENU SELECTION NOT FOUND!"
450 END
460 PRINT "ABORT --> QUIT MENU"
470 END
480 CLS
490 PRINT "PIC32 Time: ",TIME$
500 PRINT "PIC32 Date: ",DATE$
510 INPUT "Hit CR To Continue "; Query$
520 GOTO 110
530 CLS 
540 RUN "B:P_RTC_R1.bas" ' Get and Print DS3231 Time / Date / DOW 
550 INPUT "Hit CR To Continue "; Query$ 
560 CLS
570 RUN "B:Menu_R1.bas"
580 CLS
590 RUN "B:ARRTC_R1.bas"
600 CLS
610 RUN "B:ADD1RTC.bas"
620 CLS
630 RUN "B:SUB1RTC.bas"
640 CLS
650 RUN "B:ASRTC_R1.bas"
660 CLS
670 RUN "B:MSRTC_R1.bas"
680 CLS
690 RUN "B:Clocks_P.bas"                                       
700 CLS
710 GOSUB 940
720 INPUT "Hit CR To Continue "; Query$
730 CLS
740 GOTO 110
750 CLS
760 RUN "B:PIC32DOW.bas"
770 CLS
780 RUN "B:PIC32DOY.bas"
785 CLS
786 RUN "B:SR_SS_R1.bas"
790 '===========================================================================
800 '                    DST Algorithm - For Test ONLY!
810 '===========================================================================
820 '--------DST_R1.bas-----------
830 '------------- Adjust Time For DST-------------
840 'Author: Hacker - DuinoMiteMegaAndy
850 'Date: 27/11/2011
860 'App. Version: Rev. 1.0b
870 'MMBasic Firmware: 2.7 DuinoMite Mega
880 'Platform: Win XP/SP3
890 '
900 '
910 '----------Code Begin--------------
920 'Spring Forward and Fall Back Dates for time change at 02:00 AM.
930 'DST data date format matches PIC32 Date$: Month/Day/Year xxxx
940 DATA "11-3-2012","4-11-2012","10-3-2013","11-3-2013","9-3-2014"
950 DATA "2-11-2014", "8-3-2015","1-11-2015","13-3-2016","6-11-2016"
960 DATA "12-3-2017","5-11-2017","11-3-2018","4-11-2018","10-3-2019"
970 DATA "3-11-2019" 
980 DIM DSTDate$(15)
990 'Read data into zero base array
1000 FOR I=0 TO 15 ' 8 years of DST dates 
1010 READ DSTDate$(I)
1020 NEXT I
1030 FOR I=0 TO 15 ' 8 years of DST dates
1040 IF DATE$ = DSTDate$(I) THEN GOTO 1150
1050 NEXT I
1060 '
1070 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1080 ? #9, "NO_DST_KEY"
1090 CLOSE #9
1100 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
1110 ? #8, "DST_UNLOCKED"
1120 CLOSE #8
1130 ? "DST Date Not Found!" 
1140 RETURN '<---<<<<
1150 OPEN "B:CHKDST.dat" FOR OUTPUT AS #9
1160 ? #9, "DST_IS_TODAY"
1170 CLOSE #9
1180 OPEN "B:CHKDST.dat" FOR INPUT AS #9
1190 INPUT #9, key$
1200 CLOSE #9
1210 OPEN "B:Lockout.dat" FOR INPUT AS #8
1220 INPUT #8, lockout$
1230 CLOSE #8 
1240 IF key$ = "DST_IS_TODAY" AND lockout$ = "DST_UNLOCKED" THEN GOTO 1270
1250 ? "DST Has been done once - DST Lockout"   
1260 RETURN ' <---<<<
1270 tempdec = VAL(LEFT$(TIME$, 2))
1280 hours_dec = tempdec 
1290 GOSUB 1850
1300 hours = hex
1310 tempdec = VAL(MID$(TIME$, 4, 2)) 
1320 GOSUB 1850
1330 minutes = hex
1340 tempdec = VAL(RIGHT$(TIME$, 2))
1350 GOSUB 1850
1360 seconds = hex
1370 tempdec = VAL(LEFT$(DATE$, 2))
1380 DOW_DAY = tempdec
1390 GOSUB 1850
1400 day = hex
1410 tempdec = VAL(MID$(DATE$, 4, 2))
1420 DOW_MONTH = tempdec
1430 month_dec = tempdec 
1440 GOSUB 1850
1450 month = hex
1460 tempdec = (VAL(RIGHT$(DATE$, 4)) - 2000)
1470 DOW_YEAR = tempdec
1480 GOSUB 1850
1490 year = hex
1500 IF month_dec = 3 THEN GOTO 1540 'Spring forward +1 hr 
1510 IF month_dec = 11 THEN GOTO 1560 'Fall back -1 hr
1520 ? "ABORT ---> DST Month Error!"
1530 RETURN <----<<<<<
1540 IF hours_dec = 23 THEN hours_dec = 0: GOSUB 1850: GOTO 1690 ' ADD +1 to military time
1550 IF hours_dec >= 0 AND  hours_dec < 23  THEN hours_dec = hours_dec + 1:GOSUB 1850: GOTO 1690 ' ADD +1 to military time     
1560 IF hours_dec >= 1 AND  hours_dec <= 23 THEN hours_dec = hours_dec - 1:GOSUB 1850: GOTO 1690 ' SUBTRACT -1 to military time
1570 IF hours_dec = 0  THEN hours_dec = 23:GOSUB 1850: GOTO 1690 'SUBTRACT -1 to military time 
1580 a = (14 - dow_month) / 12
1590 a = FIX(a)
1600 y = dow_year - a
1610 y = FIX(y)
1620 m = dow_month + (12 * a) - 2
1630 m = FIX(m)
1640 d = ((dow_day + y) + FIX(y / 4) - FIX(y / 100) + FIX(y / 400) + FIX((31 * m) / 12)) 
1650 DOW = d MOD 7
1660 DOW = DOW + 1 ' offset for DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
1670 tempdec = DOW ' DOW dec
1680 GOSUB 1860 ' convert to hex BCD
1690 rtcwday= hex
1700 ' Write DST adjusted Time to DS3231 RTC
1710 i2caddr = &h68 ' DS3231 I2C address
1720 I2CEN 400,100 ' Enable I2C
1730 I2CSEND i2caddr, 0, 8, &h0, seconds, minutes, hours_dec, rtcwday, day, month, year 
1740 I2CDIS
1750 ? "0=ok 1=nack 2=timeout"; MM.I2C
1760 ? "DST has updated the DS3231 RTC!";
1770 OPEN "B:DST.dat" FOR OUTPUT AS #9 ' write status to dat file
1780 ? #9,"DST_UPDATED"
1790 ? #9,DATE$
1800 CLOSE #9
1810 OPEN "B:LOCKOUT.dat" FOR OUTPUT AS #8
1820 ? #8, "DST_LOCKED"
1830 CLOSE #8
1840 RETURN ' <---<<<< 
1850 'Convert to Hex
1860 hex = FIX(tempdec / 10) * 16
1870 hex = hex OR ((tempdec / 10) - (FIX(tempdec / 10))) * 10
1880 RETURN ' <---<<<<
1890 '  
